# GITTERNETZSTERNE: VIELECKE MIT VERBINDUNGSLINIEN
# Name: Gitternetzstern.py

from turtle import *

speed(0)
shape("turtle")


###########  GITTERNETZSTERNE: VIELECKE MIT VERBINDUNGSLINIEN
## Die Koordinaten der  Eckpunkte werden beim Zeichnen des Vielecks
## in einer Eckenliste[] gespeichert. Dann wird von jedem Eintrag in der
## Liste zu jedem anderen eine Linie gemalt.
## Am Schluss wird das umgebende Vieleck ausradiert (weiß übermalt).


def Vieleck_mit_Liste(Ecken,Schritte):
    global Eckenliste
    Winkel = 360/Ecken
    for i in range(Ecken):
        forward(Schritte)
        Eckenliste.append([int(xcor()),int(ycor())]) # Eckenposition merken
        left(Winkel)
    
def zeichne_alle_Verbindungen():
    for aE in range(len(Eckenliste)):
        aktuelleEcke = Eckenliste[aE]      # aktuelle Ecke: Koordinaten lesen
        aE_x = aktuelleEcke[0]
        aE_y = aktuelleEcke[1]
        goto(aE_x,aE_y)                    # setze dich in aktuelle Ecke
        for nZ in range(len(Eckenliste)):
            naechstesZiel = Eckenliste[nZ] # nächstes Ziel: Koordinaten lesen
            nZ_x = naechstesZiel[0]
            nZ_y = naechstesZiel[1]
            goto(nZ_x,nZ_y)                # male Linie von aE nach nZ
            goto(aE_x,aE_y)                # zurück zur aktuellen Ecke


def zeichne_je_Ecke_zwei_Verbindungen():
    for aE in range(len(Eckenliste)):
        aktuelleEcke = Eckenliste[aE]    # aktuelle Ecke: Koordinaten lesen
        aE_x = aktuelleEcke[0]
        aE_y = aktuelleEcke[1]
        goto(aE_x,aE_y)                  # setze dich in aktuelle Ecke

        gE = aE + int(len(Eckenliste)/2) # gE liegt aE gegenüber
        
        # erste Verbindung zum rechten Nachbarn von gE
        Ziel1_Index = (gE -1) % len(Eckenliste) # rechter Nachbar von gE
        Ziel1 = Eckenliste[Ziel1_Index]
        Z1_x = Ziel1[0]
        Z1_y = Ziel1[1]
        goto(Z1_x,Z1_y) # Linie malen von aE nach Z1
        goto(aE_x,aE_y) # und zurück

        # zweite Verbindung zum linken Nachbarn von gE
        Ziel2_Index = (gE + 1) % len(Eckenliste) # linker Nachbar von gE
        Ziel2 = Eckenliste[Ziel2_Index]
        Z2_x = Ziel2[0]
        Z2_y = Ziel2[1]
        goto(Z2_x,Z2_y)
        goto(aE_x,aE_y)
        
####### PROGRAMM

## VARIABLEN
Eckenliste = []

## Verschiebe Anfangsposition nach unten
penup()
setpos(0,-200)
pendown()

## Gitternetzstern als Vieleck mit allen oder mit je 2 Verbindungen

Vieleck_mit_Liste(120,15)   # (Ecken,Schritte) 
#zeichne_alle_Verbindungen()
zeichne_je_Ecke_zwei_Verbindungen()
color("white")
width(4)
Vieleck_mit_Liste(120,15)   # übermale äußeres Vieleck
hideturtle()                # verstecke die Schildkröte


