# Malt Sierpinski-Dreiecke: Funktion Sierpinski
#   - Seitenlänge: Länge der Seiten des aktuellen Dreiecks
#   - RT: Rekursionstiefe
#
# Name: Sierpinski.py

from random import *  # für Zufallsfarben
from turtle import *

shape("turtle")
speed(5)

def Dreieck(Seitenlänge):
        for i in range(0,3):
            forward(Seitenlänge)
            left(120)
 
# Für buntes Sierpinski-Dreieck anstelle von "Dreieck" aufrufen
def BuntesDreieck(Seitenlänge):
    color(random(),random(),random())
    begin_fill()
    for i in range(0,3):
            forward(Seitenlänge)
            left(120)
    end_fill()

def Sierpinski(Seitenlänge,RT):
    if RT > 0:
    # 1. Male drei Sierpinski-Dreiecke in die drei Ecken    
        Sierpinski(Seitenlänge/2,RT-1) # erstes Dreieck links unten

        forward(Seitenlänge/2)         # gehe zu Mitte der unteren Seite
        
        Sierpinski(Seitenlänge/2,RT-1) # zweites Dreieck rechts unten

        backward(Seitenlänge/2)        # gehe zur Mitte der linken Seite
        left(60)
        forward(Seitenlänge/2)
        right(60)
        
        Sierpinski(Seitenlänge/2,RT-1) # drittes Dreieck oben

        left(60)                       # zurück auf Anfang links unten
        backward(Seitenlänge/2)
        right(60)
    else:
        # 2. Beim kleinsten Level angekommen: Male ein einzelnes Dreieck
        BuntesDreieck(Seitenlänge)
   

# Programm beginnt

width(1)
Seitenlänge = 300
RT = 4

Sierpinski(Seitenlänge,RT)

exitonclick()

