# Sierpinskiteppich.py
# Webt einen rekursiven Teppich aus Quadraten
# - In jedem Level erhält das aktuelle Quadrat 8 Kind-Quadrate

from turtle import *
from random import *

shape("turtle")
#speed(0)
tracer(0)

def Quadrat(Breite):
    pendown()
    # color(random(),random(),random())
    begin_fill()
    for i in range(4):
        forward(Breite)
        left(90)
    end_fill()
    penup()

def Sierpinskiteppich(Breite, RT):
    if RT == 0:
        Quadrat(Breite)
    else:
        Quadrat(Breite)  # Großes Quadrat in der Mitte
        KBreite = Breite/3
      
        goto(xcor() - 2*KBreite, ycor() - 2*KBreite) # zur Ecke links unten
        Sierpinskiteppich(KBreite, RT-1) # Viereck links unten

        goto(xcor(), ycor() + 3*KBreite) # zur Mitte links
        Sierpinskiteppich(KBreite, RT-1) # Viereck Mitte links

        goto(xcor(), ycor() + 3*KBreite) # zur Ecke links oben
        Sierpinskiteppich(KBreite, RT-1) # Viereck links oben

        goto(xcor() + 3*KBreite, ycor()) # zur Mitte oben
        Sierpinskiteppich(KBreite, RT-1) # Viereck Mitte oben

        goto(xcor() + 3*KBreite, ycor()) # zur Ecke rechts oben
        Sierpinskiteppich(KBreite, RT-1) # Viereck rechts oben

        goto(xcor(), ycor() - 3*KBreite) # zur Mitte rechts
        Sierpinskiteppich(KBreite, RT-1) # Viereck Mitte rechts

        goto(xcor(), ycor() - 3*KBreite) # zur Ecke rechts unten
        Sierpinskiteppich(KBreite, RT-1) # Viereck rechts unten

        goto(xcor() - 3*KBreite, ycor()) # zur Mitte unten
        Sierpinskiteppich(KBreite, RT-1) # Viereck Mitte unten

        goto(xcor() - KBreite, ycor() + 2*KBreite) # zur Startposition
       
        
################  PROGRAMM  #############################

Sierpinskiteppich(200, 4) # (Breite, Rekursionstiefe)
hideturtle()
update()


##tracer(0, 0)
##
##penup()
##goto(-300, 0)
##SierpinskiTeppich(50, 1)
##
##penup()
##goto(-150, 0)
##SierpinskiTeppich(50, 2)
##
##penup()
##goto(40, 0)
##SierpinskiTeppich(50, 3)
##
##penup()
##goto(250, 0)
##SierpinskiTeppich(50, 4)
##
##hideturtle()
##
##update()

exitonclick()
