# Malt einen Winterwald aus Bäumen und Schneeflocken.
# Benutzt den Code aus Wald.py und Schneeflocken.py
#
# Name: Winterwald.py ##############################

from turtle import *
from random import *

shape("turtle")
bgcolor("gray")

# Schneeflockenseiten

def SeiteStumpfNachUnten(Schritte, RT):
    if RT > 0:  # mache aus der Seite ein Türmchen (mit 5 Seiten) 
       SeiteStumpfNachUnten(Schritte/3, RT-1) 

       right(90)
       SeiteStumpfNachUnten(Schritte/3, RT-1)

       left(90)
       SeiteStumpfNachUnten(Schritte/3, RT-1)

       left(90)
       SeiteStumpfNachUnten(Schritte/3, RT-1)

       right(90)
       SeiteStumpfNachUnten(Schritte/3, RT-1) 
    else:  # Male eine gerade Linie der Länge Schritte 
       forward(Schritte)

def SeiteSpitzNachOben(Schritte, RT):
    if RT > 0:
        # mache aus der Seite eine Spitze (mit 4 Seiten)
        SeiteSpitzNachOben(Schritte/3, RT-1) 
        left(60)
    
        SeiteSpitzNachOben(Schritte/3, RT-1)
        right(120)
    
        SeiteSpitzNachOben(Schritte/3, RT-1)
        left(60)
    
        SeiteSpitzNachOben(Schritte/3, RT-1)
    else:
        # Male eine gerade Linie der Länge Schritte
        forward(Schritte)

# Flocken, die sich aus Schneeflockenseiten zusammensetzen  
def StumpfeFlocke(Schritte, Ecken, RT):
        for i in range(Ecken):
            right(360/Ecken)
            SeiteStumpfNachUnten(Schritte, RT) 
          
def SpitzeFlocke(Schritte, Ecken, RT):
        for i in range(Ecken):
            right(360/Ecken)
            SeiteSpitzNachOben(Schritte, RT)

            
# Baum (siehe Baum.py) ohne Blätter

def Baum(Winkel, Astlänge, Astdicke, RT):
    # 1. Male einen Ast (den Stamm der Gabelung)
    width(Astdicke)
    forward(Astlänge)
    # 2. Male die Gabelung: Rufe zweimal Baum auf
    if RT > 0:
        left(Winkel)
        Baum(Winkel, 0.8*Astlänge, 0.7*Astdicke, RT-1)
        
        backward(0.8*Astlänge)
        
        right(Winkel*2)
        Baum(Winkel, 0.8*Astlänge, 0.7*Astdicke, RT-1)

        backward(0.8*Astlänge)
        left(Winkel)
    else:
   # 3. male die letzte Astgabelung an der Spitze
 
        left(Winkel)
        forward(0.8*Astlänge)
        backward(0.8*Astlänge)
        right(Winkel*2)
        forward(0.8*Astlänge)
        backward(0.8*Astlänge)
        left(Winkel)
 

# Programm beginnt


# Male verschiedene schwarze, kahle Bäume an verschiedenen Positionen
# Rufe auf: Baum(Winkel, Astlänge, Astdicke, RT)

color("black")

penup()
home()
left(90)
setpos(-200,0)
pendown()
Baum(30,40,10,4)

penup()
home()
left(90)
setpos(100,-50)
pendown()
Baum(35,60,15,5)

penup()
home()
left(90)
setpos(-100,-100)
pendown()
Baum(35,50,12,4)

penup()
home()
left(90)
setpos(-50,100)
pendown()
Baum(25,50,10,3)


penup()
home()
left(90)
setpos(150,-150)
pendown()
Baum(30,40,12,4)

# Male verschiedene Schneeflocken an zufälligen Positionen
# Rufe auf: Flocke(Schritte,Ecken,RT)

color("white")
width(1)

# Male 60 stumpfe Flocken, 5-eckige Grundform
for i in range(15):
    penup()
    setpos(280*random(),280*random())
    pendown()
    StumpfeFlocke(20,5,2)
    penup()
    setpos(-280*random(),-150*random())
    pendown()
    StumpfeFlocke(20,5,2)
    penup()
    setpos(-280*random(),280*random())
    pendown()
    StumpfeFlocke(20,5,2)
    penup()
    setpos(280*random(),-150*random())
    pendown()
    StumpfeFlocke(20,5,2)

# Male 60 spitze Flocken, 3-eckige Grundform
for i in range(15):
    penup()
    setpos(280*random(),280*random())
    pendown()
    SpitzeFlocke(20,3,2)
    penup()
    setpos(-280*random(),-150*random())
    pendown()
    SpitzeFlocke(20,3,2)
    penup()
    setpos(-280*random(),280*random())
    pendown()
    SpitzeFlocke(20,3,2)
    penup()
    setpos(280*random(),-150*random())
    pendown()
    SpitzeFlocke(20,3,2)


exitonclick()



