from turtle import *
from random import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Snake - Das Spiel!") # Titelzeile
    Spielfeld.bgcolor("lightgreen")       # Hintergrundfarbe
    Spielfeld.setup(Breite, Hoehe)        # Größe

def initSchlange():
    Snake.speed(1)           # Die Schlange ist langsam,
    Snake.shape("circle")    # der Kopf ist ein Kreis
    Snake.color("black")     # und schwarz.
    Snake.richtung = "keine" # Sie hat zunächst keine Richtung,
    Snake.penup()            # sie hinterlässt keine Spur,
    Snake.goto(0, 100)       # und sie startet hier.

def initFutter():
    Futter.shape("turtle")      # Das Futter hat Schildkrötenform
    Futter.color("red")         # und ist rot.
    Futter.penup()              # Es hinterlässt keine Spur,
    Futter.speed(0)             # kann sich schnell bewegen
    Futter.setposition(100,100) # und liegt am Anfang hier.

def initRichtung():
    Spielfeld.listen() # das Spielfeld lauscht auf die Tasten
    Spielfeld.onkey(gehe_hoch,   "Up")
    Spielfeld.onkey(gehe_runter, "Down")
    Spielfeld.onkey(gehe_rechts, "Right")
    Spielfeld.onkey(gehe_links,  "Left")
    Spielfeld.onkey(stoppe,      "space")
    
def gehe_hoch():
        Snake.richtung = "hoch"
def gehe_runter():
        Snake.richtung = "runter"
def gehe_rechts():
        Snake.richtung = "rechts"
def gehe_links():
        Snake.richtung = "links"       
def stoppe():
        Snake.richtung = "keine"

def bewegeSchlange():
    x = Snake.xcor()               # (x,y): Position der Schlange          
    y = Snake.ycor()
    if Snake.richtung == "hoch":   # Gehe 20 Pixel nach oben
        Snake.sety(y+20)  
    if Snake.richtung == "runter": # Gehe 20 Pixel nach unten
        Snake.sety(y-20)  
    if Snake.richtung == "rechts": # Gehe 20 Pixel nach rechts
        Snake.setx(x+20)  
    if Snake.richtung == "links":  # Gehe 20 Pixel nach links 
        Snake.setx(x-20)     

def initAnzeige():
    Anzeige.color("black")  # Der Text ist weiß
    Anzeige.hideturtle()    # das Turtlesymbol ist unsichtbar
    Anzeige.penup()         # die Anzeige hinterlässt keine Spur
    Anzeige.setposition(-Breite/2+40, Hoehe/2-40)  # links oben
    Anzeige.write("Punkte: "+str(Punkte), font=("Courier", 14, "bold"))

def updateAnzeige():
    Anzeige.clear()
    Anzeige.write("Punkte: "+str(Punkte), font=("Courier", 14, "bold"))


######## PROGRAMM:
        
Spielfeld = Screen()
Snake = Turtle()
Futter = Turtle()
Anzeige = Turtle()
Breite = 600
Hoehe = 540
Punkte = 0

initSpielfeld(Breite,Hoehe)  
initSchlange()
initFutter()
initRichtung()
initAnzeige()
Spielfeld.update()


while True:
    bewegeSchlange()
    Spielfeld.update()
    if Snake.position() == Futter.position(): # Futter gefunden
        fx = randrange(-280,280,20)     # neue Zufallsposition (fx,fy)
        fy = randrange(-260,260,20)
        Futter.setposition(fx,fy)        
        Punkte = Punkte + 1             # Punkte erhöhen
        updateAnzeige()                 # und anzeigen


