from turtle import *
from random import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Snake - Das Spiel!")
    Spielfeld.bgcolor("lightgreen")
    Spielfeld.setup(Breite, Hoehe)

def initSchlange():
    Snake.speed(1)           # Die Schlange ist langsam,
    Snake.shape("circle")    # der Kopf ist ein Kreis
    Snake.color("black")     # und schwarz.
    Snake.richtung = "keine" # Zuerst hat sie keine Richtung.
    Snake.penup()            # Sie hinterlässt keine Spur.
    Snake.setposition(0,0)   # Hier sitzt sie am Anfang.

def initFutter():
    Futter.shape("turtle")      # Das Futter hat Schildkrötenform
    Futter.color("red")         # und ist rot.
    Futter.penup()              # Es hinterlässt keine Spur,
    Futter.speed(0)             # kann schnell bewegt werden
    Futter.setposition(100,100) # und liegt hier.

def initRichtung():
    Spielfeld.listen()       # das Spielfeld lauscht auf die Tasten
    Spielfeld.onkey(gehe_hoch,   "Up")  # Kombi: onkey(Funktion,Event)
    Spielfeld.onkey(gehe_runter, "Down")
    Spielfeld.onkey(gehe_rechts, "Right")
    Spielfeld.onkey(gehe_links,  "Left")
    Spielfeld.onkey(stoppe,      "space")
    
def gehe_hoch():                 # Die Funktionen zu den Events
        if(Snake.richtung != "runter"):
            Snake.richtung = "hoch"
def gehe_runter():
        if(Snake.richtung != "hoch"):
            Snake.richtung = "runter"
def gehe_rechts():
        if(Snake.richtung != "links"):
            Snake.richtung = "rechts"
def gehe_links():
        if(Snake.richtung != "rechts"):
            Snake.richtung = "links"       
def stoppe():
        Snake.richtung = "keine"

def bewegeSchlange():
    x = Snake.xcor()               # (x,y): Position der Schlange      
    y = Snake.ycor()
    if Snake.richtung == "hoch":   # Gehe 20 Pixel nach oben
        Snake.sety(y+20)  
    if Snake.richtung == "runter": # Gehe 20 Pixel nach unten
        Snake.sety(y-20)  
    if Snake.richtung == "rechts": # Gehe 20 Pixel nach rechts
        Snake.setx(x+20)  
    if Snake.richtung == "links":  # Gehe 20 Pixel nach links 
        Snake.setx(x-20)
    updateSchlangenkoerper()
   
def initPunkteAnzeige():
    Anzeige.color("black")  # Der Text ist schwarz
    Anzeige.hideturtle()    # das Turtlesymbol ist unsichtbar
    Anzeige.penup()         # die Anzeige hinterlässt keine Spur
    Anzeige.setposition(-Breite/2+40, Hoehe/2-40)  # links oben
    Anzeige.write("Punkte: "+str(Punkte), font=("Courier", 14, "bold"))

def updateAnzeige():  # Aktualisiere die Punktestandsanzeige
    Anzeige.clear()
    Anzeige.write("Punkte: "+str(Punkte), font=("Courier", 14, "bold"))

def versetzeFutter():
    linkerRand =  int(-Breite/2+20)
    rechterRand = int(Breite/2-20)
    obererRand =  int(Hoehe/2-20)
    untererRand = int(-Hoehe/2+20)
    # neue Futterposition (fx,fy) zwischen den Spielfeldrändern:
    fx = randrange(linkerRand,rechterRand,20)  
    fy = randrange(untererRand,obererRand,20)
    Futter.setposition(fx,fy)
    
def neuesSegment():
    Segment = Turtle()
    Segment.hideturtle() 
    Segment.speed(0)
    Segment.shape("circle")
    Segment.color("grey")
    Segment.penup() 
    Segment.setposition(Snake.position()) # Übernimm Position der Schlange
    Segment.showturtle()
    Schlangenkoerper.append(Segment)      # Füge Segment der Liste hinzu


def updateSchlangenkoerper():
    if len(Schlangenkoerper) > 0:
        # Das letzte Segment übernimmt den ersten Listenplatz:
        letztesSegment = Schlangenkoerper[len(Schlangenkoerper)-1]
        Schlangenkoerper.remove(letztesSegment)
        Schlangenkoerper.insert(0,letztesSegment)
        # und es bekommt die bisherige Schlangenkopfposition:
        letztesSegment.setposition(Snake.position())

 
### DIESE VERSION VERSCHIEBT ALLE SEGMENTE UND MACHT DAS PROGRAMM LANGSAM:
##def updateSchlangenkoerper():       
##    # Gehe die Segmente-Liste von hinten nach vorne durch:
##    for index in range(len(Schlangenkoerper)-1,0,-1):
##        aktuellesSegment = Schlangenkoerper[index]
##        vorigesSegment = Schlangenkoerper[index-1]
##        # Aktuelles Segment übernimmt Position vom Vorgängersegment:
##        aktuellesSegment.setposition(vorigesSegment.position())
##    # Erstes Segment übernimmt Position vom Schlangenkopf
##    if len(Schlangenkoerper) > 0:
##        Schlangenkoerper[0].setposition(Snake.position())



def wirdRandBeruehrt():
    if Snake.xcor() > Breite/2:
        return True
    if Snake.xcor() < -Breite/2:
        return True    
    if Snake.ycor() > Hoehe/2:
        return True
    if Snake.ycor() < -Hoehe/2:
        return True
    else:
        return False
    
def wirdKoerperBeruehrt():
    if len(Schlangenkoerper) > 2:
        for index in range(2,len(Schlangenkoerper)-1):
            Segment = Schlangenkoerper[index]
            if Snake.position() == Segment.position():
                return True
        return False
    return False
    
def Spielende():
    global Punkte
    for Segment in Schlangenkoerper: 
        Segment.hideturtle()  # mache die Segmente unsichtbar
    Schlangenkoerper[:] = []  # leere die Schlangekörper-Liste
    Snake.hideturtle()
    Snake.speed(0)
    Snake.setposition(0, 0)   # Setze Schlangenkopf in die Mitte
    Snake.showturtle()
    Snake.richtung = "keine"  # und stoppe seine Bewegung.
    Snake.speed(1)            # Wieder auf Anfangsgeschwindigkeit
    Anzeige.clear()
    Anzeige.setposition(-Breite/2+10, Hoehe/2-40)
    Anzeige.write("Game Over. Du hast "+ str(Punkte) + " Punkte erreicht.", font=("Courier", 14, "bold"))
    Punkte = 0                # Punkte auf 0 zurücksetzen

    
######## PROGRAMM:

## OBJEKTE
Spielfeld = Screen()
Snake = Turtle()
Futter = Turtle()
Anzeige = Turtle()

## VARIABLEN
Breite = 560
Hoehe = 480
Punkte = 0
Schlangenkoerper = []

## INITIALISIERUNGEN
initSpielfeld(Breite,Hoehe)  
initSchlange()
initFutter()
initRichtung()
initPunkteAnzeige()
Spielfeld.update()   # Zeige Anfangsspielfeld

## DAS SPIEL
while True:
    bewegeSchlange()
    Spielfeld.update()
    if Snake.position() == Futter.position(): # Futter gefunden!
        versetzeFutter()
        Punkte = Punkte + 1         # berechne neuen Punktestand
        updateAnzeige()             # aktualisiere Anzeige 
        neuesSegment()              # lasse die Schlange wachsen
    if wirdRandBeruehrt():
        Spielende()
    if wirdKoerperBeruehrt():
        Spielende()
  
 

