from turtle import *
from random import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Snake - Das Spiel!")
    Spielfeld.bgcolor("lightgreen")
    Spielfeld.setup(Breite, Hoehe)

def initSchlange():
    Snake.speed(1)           # Die Schlange ist langsam,
    Snake.shape("circle")    # der Kopf ist ein Kreis
    Snake.color("black")     # und schwarz.
    Snake.richtung = "keine" # Zuerst hat sie keine Richtung.
    Snake.penup()            # Sie hinterlässt keine Spur.
    Snake.setposition(0,0)   # Hier sitzt sie am Anfang.

def initFutter():
    Futter.shape("turtle")      # Das Futter hat Schildkrötenform
    Futter.color("red")         # und ist rot.
    Futter.penup()              # Es hinterlässt keine Spur,
    Futter.speed(0)             # kann schnell bewegt werden
    Futter.setposition(100,100) # und liegt hier.

def initRichtung():
    Spielfeld.listen()       # das Spielfeld lauscht auf die Tasten
    Spielfeld.onkey(gehe_hoch,   "Up")  # Kombi: onkey(Funktion,Event)
    Spielfeld.onkey(gehe_runter, "Down")
    Spielfeld.onkey(gehe_rechts, "Right")
    Spielfeld.onkey(gehe_links,  "Left")
    Spielfeld.onkey(stoppe,      "space")
    
def gehe_hoch():                 # Die Funktionen zu den Events
        if(Snake.richtung != "runter"):
            Snake.richtung = "hoch"
def gehe_runter():
        if(Snake.richtung != "hoch"):
            Snake.richtung = "runter"
def gehe_rechts():
        if(Snake.richtung != "links"):
            Snake.richtung = "rechts"
def gehe_links():
        if(Snake.richtung != "rechts"):
            Snake.richtung = "links"       
def stoppe():
        Snake.richtung = "keine"

def bewegeSchlange():
    x = Snake.xcor()               # (x,y): Position der Schlange      
    y = Snake.ycor()
    if Snake.richtung == "hoch":   # Gehe 20 Pixel nach oben
        Snake.sety(y+20)  
    if Snake.richtung == "runter": # Gehe 20 Pixel nach unten
        Snake.sety(y-20)  
    if Snake.richtung == "rechts": # Gehe 20 Pixel nach rechts
        Snake.setx(x+20)  
    if Snake.richtung == "links":  # Gehe 20 Pixel nach links 
        Snake.setx(x-20)
    updateSchlangenkoerper()
   
def initPunkteAnzeige():
    PunkteAnzeige.color("black")  # Der Text ist schwarz
    PunkteAnzeige.hideturtle()    # das Turtlesymbol ist unsichtbar
    PunkteAnzeige.penup()         # die Anzeige hinterlässt keine Spur
    PunkteAnzeige.setposition(-Breite/2+40, Hoehe/2-40)  # links oben
    PunkteAnzeige.write("Punkte: "+str(Punkte), font=("Courier", 14, "bold"))

def initHighscoreAnzeige():
    HighscoreAnzeige.color("blue")   # Der Text ist blau
    HighscoreAnzeige.hideturtle()    # das Turtlesymbol ist unsichtbar
    HighscoreAnzeige.penup()         # die Anzeige hinterlässt keine Spur
    HighscoreAnzeige.setposition(-Breite/2+40, -Hoehe/2+40)  # links oben
    HighscoreAnzeige.write("Highscore: "+str(Highscore), font=("Courier", 14, "bold"))

def updateAnzeige():  # Aktualisiere die Anzeige von Punkten und Highscore
    PunkteAnzeige.clear()
    HighscoreAnzeige.clear()
    PunkteAnzeige.write("Punkte: "+str(Punkte), font=("Courier", 14, "bold"))
    HighscoreAnzeige.write("Highscore: "+str(Highscore), font=("Courier", 14, "bold"))

def versetzeFutter():
    linkerRand =  int(-Breite/2+20)
    rechterRand = int(Breite/2-20)
    obererRand =  int(Hoehe/2-20)
    untererRand = int(-Hoehe/2+20)
    # neue Futterposition (fx,fy) zwischen den Spielfeldrändern:
    fx = randrange(linkerRand,rechterRand,20)  
    fy = randrange(untererRand,obererRand,20)
    Futter.setposition(fx,fy)
    
def neuesSegment():
    Segment = Turtle()
    Segment.hideturtle() 
    Segment.speed(0)
    Segment.shape("circle")
    Segment.color("grey")
    Segment.penup() 
    Segment.setposition(Snake.position()) # Übernimm Position der Schlange
    Segment.showturtle()
    Schlangenkoerper.append(Segment)      # Füge Segment der Liste hinzu


def updateSchlangenkoerper():
    if len(Schlangenkoerper) > 0:
        # Das letzte Segment übernimmt den ersten Listenplatz:
        letztesSegment = Schlangenkoerper[len(Schlangenkoerper)-1]
        Schlangenkoerper.remove(letztesSegment)
        Schlangenkoerper.insert(0,letztesSegment)
        # und es bekommt die bisherige Schlangenkopfposition:
        letztesSegment.setposition(Snake.position())

 
### DIESE VERSION VERSCHIEBT ALLE SEGMENTE UND MACHT DAS PROGRAMM LANGSAM:
##def updateSchlangenkoerper():       
##    # Gehe die Segmente-Liste von hinten nach vorne durch:
##    for index in range(len(Schlangenkoerper)-1,0,-1):
##        aktuellesSegment = Schlangenkoerper[index]
##        vorigesSegment = Schlangenkoerper[index-1]
##        # Aktuelles Segment übernimmt Position vom Vorgängersegment:
##        aktuellesSegment.setposition(vorigesSegment.position())
##    # Erstes Segment übernimmt Position vom Schlangenkopf
##    if len(Schlangenkoerper) > 0:
##        Schlangenkoerper[0].setposition(Snake.position())

def werdeSchneller():
    Snake.speed(int(len(Schlangenkoerper)/10) + 1)

def wirdRandBeruehrt():
    if Snake.xcor() > Breite/2:   # rechter Rand
        return True
    if Snake.xcor() < -Breite/2:  # linker Rand
        return True    
    if Snake.ycor() > Hoehe/2:    # oberer Rand
        return True
    if Snake.ycor() < -Hoehe/2:   # unterer Rand
        return True
    else:
        return False
    
def wirdKoerperBeruehrt():
    if len(Schlangenkoerper) > 2:
        for index in range(2,len(Schlangenkoerper)-1):
            Segment = Schlangenkoerper[index]
            if Snake.position() == Segment.position():
                return True
        return False
    return False

def erscheineGegenueber():
    Tempo = Snake.speed()
    Snake.speed(0)
    Snake.hideturtle()
    if Snake.xcor() > Breite/2:  # raus nach rechts:  
        Snake.setx(-Breite/2)       # wieder rein von links
        
    if Snake.xcor() < -Breite/2: # raus nach links:
        Snake.setx(Breite/2)       # wieder rein von rechts
        
    if Snake.ycor() > Hoehe/2:   # raus nach oben:
        Snake.sety(-Hoehe/2)       # wieder rein von unten
        
    if Snake.ycor() < -Hoehe/2:  # raus nach unten:
        Snake.sety(Hoehe/2)       # wieder rein von oben
    Snake.speed(Tempo)
    Snake.showturtle()
    
def Spielende():
    global Punkte
    for Segment in Schlangenkoerper: 
        Segment.hideturtle()  # mache die Segmente unsichtbar
    Schlangenkoerper[:] = []  # leere die Schlangekörper-Liste
    Snake.hideturtle()
    Snake.speed(0)
    Snake.setposition(0, 0)   # Setze Schlangenkopf in die Mitte
    Snake.showturtle()
    Snake.richtung = "keine"  # und stoppe seine Bewegung.
    Snake.speed(1)            # Wieder auf Anfangsgeschwindigkeit
    PunkteAnzeige.clear()
    PunkteAnzeige.setposition(-Breite/2+10, Hoehe/2-40)
    PunkteAnzeige.write("Game Over. Du hast "+ str(Punkte) + " Punkte erreicht.", font=("Courier", 14, "bold"))
    Punkte = 0
    
######## PROGRAMM:

## OBJEKTE
Spielfeld = Screen()
Snake = Turtle()
Futter = Turtle()
PunkteAnzeige = Turtle()
HighscoreAnzeige = Turtle()

## VARIABLEN
Breite = 560
Hoehe = 480
Punkte = 0
Highscore = 0
Schlangenkoerper = []

## INITIALISIERUNGEN
initSpielfeld(Breite,Hoehe)  
initSchlange()
initFutter()
initRichtung()
initPunkteAnzeige()
initHighscoreAnzeige()
Spielfeld.update()   # Zeige Anfangsspielfeld

## DAS SPIEL
while True:
    bewegeSchlange()
    Spielfeld.update()
    
    if Snake.position() == Futter.position(): # Futter gefunden
        versetzeFutter()
        Punkte = Punkte + 1             # berechne neuen Punktestand
        if Punkte > Highscore:
            Highscore = Punkte          # berechne neuen Highscore
        updateAnzeige()                 # aktualisiere Anzeigen 
        neuesSegment()                  # lasse die Schlange wachsen
        werdeSchneller()                # und evtl. schneller werden
        
    if wirdRandBeruehrt():              # Bei Randberührung
        erscheineGegenueber()           # erscheint sie gegenüber.
        
    if wirdKoerperBeruehrt():           # Läuft sie in ihren Körper,
        Spielende()                     # dann endet das Spiel.


