from turtle import *
from random import *
from math import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Misthaufen - Das Spiel!") # Titel
    Spielfeld.bgcolor("lightblue")             # Farbe
    Spielfeld.setup(Breite, Hoehe)             # Größe
    hideturtle()                      # eigene Turtle unsichtbar
    penup()                           # und ohne Stift.
    speed(0)                          # Kleckse erscheinen schnell.

def initStift():
    Stift.speed(1)           # Der Stift ist langsam,
    Stift.shape("turtle")    # hat Schildkrötenform,
    Stift.color("black")     # malt schwarz,
    Stift.width(2)           # malt dick,
    Stift.richtung = "keine" # hat keine Richtung
    Stift.setposition(0, 0)  # und befindet sich in der Mitte

    
def initMisthaufen(n):
    x = randint(-(Breite/2-30), (Breite/2-30)) # Position für neuen Haufen
    y = randint(-(Hoehe/2-30), (Hoehe/2-30))
    while zuEng(x,y):               # solange zu eng an bisherigen Haufen:
        x = randint(-(Breite/2-30), (Breite/2-30))  # nochmal probieren
        y = randint(-(Hoehe/2-30), (Hoehe/2-30))
        
    setposition(x, y) 	             # Geschafft! Neuen Haufen positionieren,    
    dot(50, "orange") 	             # als orange ausgemalten Kreis malen,
    setposition(x-7, y-12)	     # Nummer positionieren
    write(str(n), font=("Arial", 14, "bold"))     # und schreiben,
    MisthaufenListe.append([x, y, n])# neuen Haufen an Liste hängen.


def zuEng(x,y):
     for h in range(len(MisthaufenListe)): # Gehe alle bisherigen Haufen durch:
        Haufen = MisthaufenListe[h]
        hx = Haufen[0]
        hy = Haufen[1]
        Abstand = dist([x, y], [hx, hy])     # Abstand zu neuem Haufen
        Stiftabstand = dist ([x, y], [0, 0]) # Abstand zum Stift
        if Abstand < 80:                     # Abstand zu Haufen zu eng (True)
            return True
        if Stiftabstand < 80:                # Abstand zu Stift zu eng (True)
            return True
     return False                            # Abstände ok (False)


######## PROGRAMM:
        
## OBJEKTE
Spielfeld = Screen()
Stift = Turtle()

## VARIABLEN
Breite = 560
Hoehe = 480
MisthaufenListe = []

## INITIALISIERUNGEN
initSpielfeld(Breite, Hoehe)  # Spielfeld und Stift initialisieren
initStift()

for i in range(20):            # 20 Misthaufen zufällig platzieren
    initMisthaufen(i+1)

Spielfeld.update()            # Zeige Ergebnis


