from turtle import *
from random import *
from math import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Misthaufen - Das Spiel!") # Titel
    Spielfeld.bgcolor("lightblue")            # Farbe
    Spielfeld.setup(Breite, Hoehe)             # Größe
    hideturtle()                      # eigene Turtle unsichtbar
    penup()                           # und ohne Stift.
    speed(0)                          # Kleckse erscheinen schnell.

def initStift():
    Stift.speed(2)           # Der Stift ist langsam,
    Stift.shape("turtle")    # hat Schildkrötenform,
    Stift.color("black")     # ist schwarz,
    Stift.width(2)           # malt dick,
    Stift.richtung = "keine" # hat keine Richtung
    Stift.penup()            # und noch keine Spur
    Stift.home()             # und läuft erstmal zur Mitte.
    Stift.pendown()          # Erst ab jetzt hinterlässt sie eine Spur.

    
def initMisthaufen(n):
    x = randint(-(Breite/2-30), (Breite/2-30)) # Position für neuen Haufen
    y = randint(-(Hoehe/2-30), (Hoehe/2-30))
    while zuEng(x,y):               # solange zu eng an bisherigen Haufen:
        x = randint(-(Breite/2-30), (Breite/2-30))  # nochmal probieren
        y = randint(-(Hoehe/2-30), (Hoehe/2-30))
        
    setposition(x, y) 	            # Geschafft! Neuen Haufen positionieren,    
    dot(50, "orange") 	            # als orange ausgemalten Kreis malen,
    setposition(x-7, y-12)	    # Nummer positionieren
    write(str(n), font=("Arial", 14, "bold"))   # und schreiben,
    MisthaufenListe.append([x, y, n, False])    # neuen Haufen an Liste hängen.

def zuEng(x,y):
     for h in range(len(MisthaufenListe)): # Gehe alle bisherigen Haufen durch:
        Haufen = MisthaufenListe[h]
        hx = Haufen[0]
        hy = Haufen[1]
        Abstand = dist([x, y], [hx, hy])     # Abstand zu neuem Haufen
        Stiftabstand = dist ([x, y], [0, 0]) # Abstand zum Stift
        if Abstand < 80:                     # Abstand zu Haufen zu eng (True)
            return True
        if Stiftabstand < 80:                # Abstand zu Stift zu eng (True)
            return True
     return False                            # Abstände ok (False)


def initRichtung():
    Spielfeld.listen() # das Spielfeld lauscht auf die Tasten
    Spielfeld.onkey(gehe_hoch,   "Up")
    Spielfeld.onkey(gehe_runter, "Down")
    Spielfeld.onkey(gehe_rechts, "Right")
    Spielfeld.onkey(gehe_links,  "Left")
    Spielfeld.onkey(stoppe,      "space")
    
def gehe_hoch():
        Stift.richtung = "hoch"
def gehe_runter():
        Stift.richtung = "runter"
def gehe_rechts():
        Stift.richtung = "rechts"
def gehe_links():
        Stift.richtung = "links"       
def stoppe():
        Stift.richtung = "keine"

def bewegeStift():
    global WegListe
    x = Stift.xcor()        
    y = Stift.ycor()
    if Stift.richtung == "hoch":   
        Stift.speed(0)             # Drehe dich (schnell) 
        Stift.setheading(90)       # nach oben
        Stift.speed(1)
        Stift.sety(y+10)           # Gehe 20 Pixel nach oben
    if Stift.richtung == "runter": 
        Stift.speed(0)             # Drehe dich (schnell)
        Stift.setheading(270)      # nach unten
        Stift.speed(1)
        Stift.sety(y-10)           # Gehe 20 Pixel nach unten
    if Stift.richtung == "rechts": 
        Stift.speed(0)             # Drehe dich (schnell)
        Stift.setheading(0)        # nach rechts
        Stift.speed(1)
        Stift.setx(x+10)           # Gehe 20 Pixel nach rechts
    if Stift.richtung == "links":  
        Stift.speed(0)             # Drehe dich (schnell)
        Stift.setheading(180)      # nach links
        Stift.speed(1)
        Stift.setx(x-10)           # Gehe 20 Pixel nach links

    if Stift.richtung != "keine":  # Wenn ein Schritt gemacht wurde:
        WegListe.append([Stift.xcor(), Stift.ycor()]) # neue Pos. eintragen
    
def checkeMisthaufen(x,y):
    global MisthaufenListe
    for i in range(len(MisthaufenListe)): # Gehe alle Haufen durch
        Haufen = MisthaufenListe[i]
        hx = Haufen[0]
        hy = Haufen[1]
        Abstand = dist([x, y], [hx, hy])
        if Abstand < 23:       # Haufen wird getroffen:
            if istDran(Haufen):   # Haufen ist als nächster dran?
                Haufen[3] = True      # als "besucht" markieren
                setposition(hx,hy)    # Haufen grau ausmalen
                dot(50, "grey")
                Stift.richtung = "keine"

def istDran(Haufen):
    if Haufen[3] == True:   # Haufen wurde schon besucht: nicht dran
        return False
    if Haufen[2] == 1:      # erster Haufen, noch nicht besucht: ist dran
        return True
    else:
        Vorgaenger = MisthaufenListe[Haufen[2]-2]
        if Vorgaenger[3] == True: # Vorgänger schon besucht, Haufen noch nicht:
            return True
    return False            # Vorgänger noch nicht besucht: Haufen nicht dran

def wirdWegBeruehrt(x,y):
    if nichtInHaufen(x,y):
        for i in range(len(WegListe)-1):
            Wegpunkt = WegListe[i]
            px = Wegpunkt[0]
            py = Wegpunkt[1]
            if x == px:
                if y == py:
                    return True
    return False

def nichtInHaufen(x,y):
     for h in range(len(MisthaufenListe)): # Gehe alle bisherigen Haufen durch:
        Haufen = MisthaufenListe[h]
        hx = Haufen[0]
        hy = Haufen[1]
        Abstand = dist([x, y], [hx, hy])   # Abstand Stift und Haufen
        if Abstand < 25:                   # Stift ist im Haufen: False
            return False
     return True                           # Stift nicht im Haufen: True

def Spielende():
    global MisthaufenListe
    global WegListe  
    clear()                  # Lösche Misthaufen
    Stift.clear()            # Lösche vorige Spur
    MisthaufenListe[:] = []  # lösche Inhalt beider Listen
    WegListe[:] = []
    initStift()
    for i in range(Haufenanzahl): # neue Misthaufen platzieren
        initMisthaufen(i+1)
    
    
######## PROGRAMM:
        
## OBJEKTE
Spielfeld = Screen()
Stift = Turtle()

## VARIABLEN
Breite = 400
Hoehe = 360
Haufenanzahl = 10
MisthaufenListe = []
WegListe = []

## INITIALISIERUNGEN
initSpielfeld(Breite, Hoehe)  # Spielfeld und Stift initialisieren
initStift()
for i in range(Haufenanzahl): # Misthaufen zufällig platzieren
    initMisthaufen(i+1)   
initRichtung()                # Lausche auf Tasten

## SPIEL IN ENDLOSSCHLEIFE
while True:
    Spielfeld.update()        # Zeige aktuelles Spielfeld
    bewegeStift()             # Bewege Stift in aktuelle Richtung
    checkeMisthaufen(Stift.xcor(),Stift.ycor()) # Checke, ob Haufen berührt
    if wirdWegBeruehrt(Stift.xcor(),Stift.ycor()):
        Spielende()

