from turtle import *
from random import *
from math import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Misthaufen - Das Spiel!") # Titel
    Spielfeld.bgcolor("lightblue")            # Farbe
    Spielfeld.setup(Breite, Hoehe)             # Größe
    hideturtle()                      # Eigene Turtle unsichtbar.
    penup()                           # und ohne Stift.
    speed(0)                          # Kleckse erscheinen schnell.

def initStift():
    Stift.shape("turtle")    # Der Stift hat Schildkrötenform,
    Stift.speed(0)           # ist erstmal schnell,
    Stift.penup()            # hat noch keine Spur
    Stift.home()             # und läuft zur Mitte.
    Stift.color("black")     # malt schwarz,
    Stift.width(2)           # malt dick,
    Stift.richtung = "keine" # hat keine Richtung
    Stift.pendown()          # Erst ab jetzt hinterlässt sie eine Spur
    Stift.speed(2)           # und läuft langsam,

def initAnzeige():
    Anzeige.color("red")    # Der Text ist rot
    Anzeige.hideturtle()    # das Turtlesymbol ist unsichtbar
    Anzeige.penup()         # die Anzeige hinterlässt keine Spur

    
def initMisthaufen(n):
    x = randint(-(Breite/2-30), (Breite/2-30)) # Position für neuen Haufen
    y = randint(-(Hoehe/2-30), (Hoehe/2-30))
    while zuEng(x,y):               # solange zu eng an bisherigen Haufen:
        x = randint(-(Breite/2-30), (Breite/2-30))  # nochmal probieren
        y = randint(-(Hoehe/2-30), (Hoehe/2-30))
        
    setposition(x, y) 	            # Geschafft! Neuen Haufen positionieren,    
    dot(50, "orange") 	            # als orange ausgemalten Kreis malen,
    setposition(x-7, y-12)	    # Nummer positionieren
    write(str(n), font=("Arial", 14, "bold"))   # und schreiben,
    MisthaufenListe.append([x, y, n, False])    # neuen Haufen an Liste hängen.

def zuEng(x,y):
     for h in range(len(MisthaufenListe)): # Gehe alle bisherigen Haufen durch:
        Haufen = MisthaufenListe[h]
        hx = Haufen[0]
        hy = Haufen[1]
        Abstand = dist([x, y], [hx, hy])     # Abstand zu neuem Haufen
        Stiftabstand = dist ([x, y], [0, 0]) # Abstand zum Stift
        if Abstand < 80:                     # Abstand zu Haufen zu eng (True)
            return True
        if Stiftabstand < 80:                # Abstand zu Stift zu eng (True)
            return True
     return False                            # Abstände ok (False)


def initRichtung():
    Spielfeld.listen()          # Das Spielfeld lauscht auf die Tasten
    Spielfeld.onkey(gehe_hoch,   "Up")
    Spielfeld.onkey(gehe_runter, "Down")
    Spielfeld.onkey(gehe_rechts, "Right")
    Spielfeld.onkey(gehe_links,  "Left")
    Spielfeld.onkey(stoppe,      "space")
    Spielfeld.onkey(Neustart, "Return")
    
def gehe_hoch():                 # Die Funktionen zu den Tasten-Events
        if(Stift.richtung != "runter"):
            Stift.richtung = "hoch"
def gehe_runter():
        if(Stift.richtung != "hoch"):
            Stift.richtung = "runter"
def gehe_rechts():
        if(Stift.richtung != "links"):
            Stift.richtung = "rechts"
def gehe_links():
        if(Stift.richtung != "rechts"):
            Stift.richtung = "links"       
def stoppe():
        Stift.richtung = "keine"

def bewegeStift():
    global WegListe
    x = Stift.xcor()        
    y = Stift.ycor()
    if Stift.richtung == "hoch":   
        Stift.speed(0)             # Drehe dich (schnell) 
        Stift.setheading(90)       # nach oben
        Stift.speed(1)
        Stift.sety(y+10)           # Gehe 20 Pixel nach oben
    if Stift.richtung == "runter": 
        Stift.speed(0)             # Drehe dich (schnell)
        Stift.setheading(270)      # nach unten
        Stift.speed(1)
        Stift.sety(y-10)           # Gehe 20 Pixel nach unten
    if Stift.richtung == "rechts": 
        Stift.speed(0)             # Drehe dich (schnell)
        Stift.setheading(0)        # nach rechts
        Stift.speed(1)
        Stift.setx(x+10)           # Gehe 20 Pixel nach rechts
    if Stift.richtung == "links":  
        Stift.speed(0)             # Drehe dich (schnell)
        Stift.setheading(180)      # nach links
        Stift.speed(1)
        Stift.setx(x-10)           # Gehe 20 Pixel nach links

    if Stift.richtung != "keine":  # Wenn ein Schritt gemacht wurde:
        WegListe.append([Stift.xcor(), Stift.ycor()]) # neue Pos. eintragen
    
def checkeMisthaufen(x,y):
    global MisthaufenListe
    for i in range(len(MisthaufenListe)): # Gehe alle Haufen durch
        Haufen = MisthaufenListe[i]
        hx = Haufen[0]
        hy = Haufen[1]
        Abstand = dist([x, y], [hx, hy])
        if Abstand < 23:       # Haufen wird getroffen:
            if istDran(Haufen):    # Haufen ist als nächster dran?
                Haufen[3] = True         # als "besucht" markieren
                setposition(hx,hy)       # Haufen grau ausmalen
                dot(50, "grey")
                Stift.richtung = "keine" # und anhalten.
                if istLetzter(Haufen):   # Besuchter Haufen ist der letzte?
                    SpielGewonnen()      # "Gewonnen"-Anzeige

def istDran(Haufen):
    if Haufen[3] == True:   # Haufen wurde schon besucht: nicht dran
        return False
    if Haufen[2] == 1:      # erster Haufen, noch nicht besucht: ist dran
        return True
    else:
        Vorgaenger = MisthaufenListe[Haufen[2]-2]
        if Vorgaenger[3] == True: # Vorgänger schon besucht, Haufen noch nicht:
            return True
    return False            # Vorgänger noch nicht besucht: Haufen nicht dran

def istLetzter(Haufen):
    if Haufen[2] == Haufenanzahl:   # Haufen trägt die höchste Nummer
        return True
    return False
    
def wirdWegBeruehrt(x,y):
    if nichtInHaufen(x,y):
        for i in range(len(WegListe)-1):
            Wegpunkt = WegListe[i]
            px = Wegpunkt[0]
            py = Wegpunkt[1]
            if x == px:
                if y == py:
                    return True
    return False

def nichtInHaufen(x,y):
     for h in range(len(MisthaufenListe)): # Gehe alle bisherigen Haufen durch:
        Haufen = MisthaufenListe[h]
        hx = Haufen[0]
        hy = Haufen[1]
        Abstand = dist([x, y], [hx, hy])   # Abstand Stift und Haufen
        if Abstand < 25:                   # Stift ist im Haufen: False
            return False
     return True                           # Stift nicht im Haufen: True

def wirdRandBeruehrt():
    if Stift.xcor() > Breite/2:   # rechter Rand
        return True
    if Stift.xcor() < -Breite/2:  # linker Rand
        return True    
    if Stift.ycor() > Hoehe/2:    # oberer Rand
        return True
    if Stift.ycor() < -Hoehe/2:   # unterer Rand
        return True
    else:
        return False

def erscheineGegenueber():
    Tempo = Stift.speed()
    Stift.speed(0)
    Stift.hideturtle()
    Stift.penup()
    if Stift.xcor() > Breite/2:  # raus nach rechts:  
        Stift.setx(-Breite/2)       # wieder rein von links
        
    if Stift.xcor() < -Breite/2: # raus nach links:
        Stift.setx(Breite/2)       # wieder rein von rechts
        
    if Stift.ycor() > Hoehe/2:   # raus nach oben:
        Stift.sety(-Hoehe/2)       # wieder rein von unten
        
    if Stift.ycor() < -Hoehe/2:  # raus nach unten:
        Stift.sety(Hoehe/2)       # wieder rein von oben
    Stift.speed(Tempo)
    Stift.showturtle()
    Stift.pendown()
    
def SpielGewonnen():
    Stift.richtung = "keine"  # Stoppe Stift
    deaktivierePfeiltasten()
    Anzeige.clear()
    Anzeige.setposition(-Breite/2+20, Hoehe/2-40)
    Anzeige.write("Herzlichen Glückwunsch!", font=("Courier", 14, "bold"))
    Anzeige.setposition(-Breite/2+20, Hoehe/2-60)
    Anzeige.write("Du hast "+ str(Haufenanzahl) + " Misthaufen bezwungen!",
                                             font=("Courier", 14, "bold"))
    Anzeige.setposition(-Breite/2+20, Hoehe/2-80)
    Anzeige.write("Neues Spiel? Enter-Taste.",font=("Courier", 14, "bold"))
                                            

def SpielVerloren():
    Stift.richtung = "keine"  # Stoppe Stift
    WegListe[:] = []
    deaktivierePfeiltasten()
    Anzeige.clear()
    Anzeige.hideturtle()
    Anzeige.penup()
    Anzeige.setposition(-Breite/2+20, Hoehe/2-40)
    Anzeige.write("Game Over.", font=("Courier", 14, "bold"))
    Anzeige.setposition(-Breite/2+20, Hoehe/2-60)
    Anzeige.write("Neues Spiel? Enter-Taste.", font=("Courier", 14, "bold"))

def deaktivierePfeiltasten():
    Spielfeld.onkey(None, "Up")
    Spielfeld.onkey(None, "Down")
    Spielfeld.onkey(None, "Right")
    Spielfeld.onkey(None, "Left")
    
def Neustart():
    global MisthaufenListe
    global WegListe
    global Anzeige
    initAnzeige()
    initStift()
    initRichtung()       # Lausche auf Tastenklicks
    clear()                  # Lösche Misthaufen
    Anzeige.clear()          # Lösche vorige Anzeige
    Stift.clear()            # Lösche vorige Spur
    MisthaufenListe[:] = []  # lösche Inhalt beider Listen
    WegListe[:] = []

    for i in range(Haufenanzahl): # neue Misthaufen platzieren
        initMisthaufen(i+1)
    
    
######## PROGRAMM:
        
## OBJEKTE
Spielfeld = Screen()
Stift = Turtle()
Anzeige = Turtle()

## VARIABLEN
Breite = 400
Hoehe = 360
Haufenanzahl = 10
MisthaufenListe = []
WegListe = []

## INITIALISIERUNGEN
initSpielfeld(Breite, Hoehe)  # Spielfeld initialisieren
Neustart()                    # Verteile Misthaufen, initialisiere Stift

## SPIEL IN ENDLOSSCHLEIFE
while True:
    Spielfeld.update()        # Zeige aktuelles Spielfeld
    bewegeStift()             # Bewege Stift in aktuelle Richtung
    checkeMisthaufen(Stift.xcor(),Stift.ycor()) # Checke, ob Haufen berührt
    
    if wirdWegBeruehrt(Stift.xcor(),Stift.ycor()):
        SpielVerloren()       # Bei Wegberührung: Spiel verloren

    if wirdRandBeruehrt():              # Bei Randberührung
        erscheineGegenueber()           # erscheint der Stift gegenüber.

