from turtle import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Parkour - Das Spiel!")    # Titel
    Spielfeld.bgcolor("lightyellow")     # Hintergrundfarbe
    Spielfeld.setup(Breite, Hoehe)       # Größe
    color("darkgreen", "lightgreen")     # Malfarbe und Füllfarbe
    shape("circle")                      # kreisförmiger Pinsel
    legeFliese(0,0)                      # 1. Fliese in der Mitte

def initKroete():
    Kroetchen.speed(1)            # Sie ist langsam,
    Kroetchen.showturtle()        # und ist jetzt sichtbar
    Kroetchen.shape("turtle")     # hat Schildkrötenform
    Kroetchen.color("brown")      # und ist braun
    Kroetchen.shapesize(2)        # und größer als normal.
    Kroetchen.penup()             # Sie hinterlässt keine Spur
    Kroetchen.home()              # startet bei (0,0)
    Kroetchen.onclick(reagiereAufKlick)  # Bei Klick auf Kroetchen: Punkt
 
def initAnzeige():
    Anzeige.color("black")  # Schriftfarbe
    Anzeige.hideturtle()    # unsichtbare Turtle
    Anzeige.penup()         # ohne Spur
    zeigePunkteAn()

def legeFliese(x, y):
    showturtle()            # Zeige Spielfeld-Turtle (Kreis)
  # gehe in eine Fliesenecke: 
    penup()
    goto(x-Fliesenseite/2, y-Fliesenseite/2)
  # male das gefüllte Fliesenquadrat:
    pendown()            
    begin_fill()
    Quadrat(Fliesenseite)
    end_fill()
  # gehe wieder zur Mitte:
    penup()
    goto(x, y)

def Quadrat(Seite):
    for i in range(4):
        forward(Seite)
        left(90)

def aktiviereTasten():
    Spielfeld.listen()   # das Spielfeld lauscht auf die Pfeiltasten
    Spielfeld.onkey(gehe_hoch,   "Up")
    Spielfeld.onkey(gehe_runter, "Down")
    Spielfeld.onkey(gehe_rechts, "Right")
    Spielfeld.onkey(gehe_links,  "Left")
    Spielfeld.onkey(laufeParkour,"space")

def gehe_hoch():
     legeFliese(xcor(), ycor() + Fliesenseite)
     Wegstrecke.append([xcor(), ycor(), 90])
     #print("Wegstrecke", Wegstrecke)
     
def gehe_runter():
     legeFliese(xcor(),ycor() - Fliesenseite)
     Wegstrecke.append([xcor(), ycor(), 270])
     #print("Wegstrecke", Wegstrecke)
     
def gehe_rechts():
     legeFliese(xcor() + Fliesenseite, ycor())
     Wegstrecke.append([xcor(), ycor(), 0])
     #print("Wegstrecke", Wegstrecke)
     
def gehe_links():
     legeFliese(xcor() - Fliesenseite, ycor())
     Wegstrecke.append([xcor(), ycor(), 180])
     #print("Wegstrecke", Wegstrecke)

def deaktiviereTasten():
    Spielfeld.onkey(None, "Up")
    Spielfeld.onkey(None, "Down")
    Spielfeld.onkey(None, "Right")
    Spielfeld.onkey(None, "Left")
    Spielfeld.onkey(None, "space")
    
def laufeParkour():
    global Punkte
    deaktiviereTasten()
    hideturtle()   # verstecke Spielfeld-Turtle
    initKroete()   # Zeige Kroetchen, aktiviere Klicken
    tracer(1)      # zeige ab jetzt jeden Kroetchen-Schritt
    Punkte = 0     # Punkte zurücksetzen und anzeigen
    zeigePunkteAn()
    for i in range(len(Wegstrecke)):
        Fliese = Wegstrecke[i]
        x_Fliese = Fliese[0]
        y_Fliese = Fliese[1]
        Kroetchen.speed(5)    # beim Drehen etwas schneller sein
        Kroetchen.setheading(Fliese[2])
        Kroetchen.speed(1)    # beim Laufen langsamer sein
        Kroetchen.setpos(x_Fliese, y_Fliese)
        
    Kroetchen.onclick(None)   # letzte Fliese erreicht: Klick-Stopp
    tracer(0)                 # ab jetzt wieder Turbo-Modus
    aktiviereTasten()         # ab jetzt wieder alles möglich


def reagiereAufKlick (x, y):
    global Punkte
    if Kroetchen.fillcolor() == ("brown"):  # wechsele die Farbe
        Kroetchen.fillcolor("red")    
    else:
        Kroetchen.fillcolor("brown")
    Punkte = Punkte + 1       # erhöhe Punkte
    zeigePunkteAn()           # und zeige sie an

def zeigePunkteAn():
    Anzeige.clear()
    Anzeige.goto(-Breite/2+30, Hoehe/2-30)     # Position für Anzeige
    Anzeige.write("Punkte: "+ str(Punkte), font=("Courier", 14, ""))
 
  
###########################
        
## OBJEKTE UND SPIELEINSTELLUNGEN
Spielfeld = Screen()
Kroetchen = Turtle()
Kroetchen.hideturtle()  # Parkour-Turtle zunächst unsichtbar
Anzeige = Turtle()
tracer(0)               # Turbo-Modus: Bild neu erst bei update()

## VARIABLEN
Breite = 600            # Breite des Spielfeldes
Hoehe  = 600            # Höhe des Spielfeldes   
Fliesenseite = 40       # Größe eines Fliesenquadrats
Wegstrecke = []         # Liste der Fliesen auf dem Weg
Punkte = 0              # Wie oft wurde Kroetchen angestupst?

## INITIALISIERUNGEN
initSpielfeld(Breite, Hoehe)  # Start-Spielfeld
initAnzeige()                 # Start-Punkteanzeige

## PROGRAMM

aktiviereTasten()       # Bei Pfeiltasten: Fliesenlegen,
                        #   bei Leertaste: Parkourlauf
while True:
    Spielfeld.update()  # Zeige Spielfeld und lausche auf Tasten





