from turtle import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Parkour - Das Spiel!") # Titel
    Spielfeld.bgcolor("lightyellow")        # Hintergrundfarbe
    Spielfeld.setup(Breite, Hoehe)          # Größe
    color("darkgreen", "lightgreen")        # Malfarbe und Füllfarbe
    shape("circle")                         # kreisförmiger Pinsel
    legeFliese(0,0)                         # 1. Fliese in der Mitte

def initKroete():
    Kroetchen.speed(1)            # Sie ist langsam,
    Kroetchen.showturtle()        # und ist jetzt sichtbar
    Kroetchen.shape("turtle")     # hat Schildkrötenform
    Kroetchen.color("brown")      # und ist braun
    Kroetchen.shapesize(2)        # und größer als normal.
    Kroetchen.penup()             # Sie hinterlässt keine Spur
    Kroetchen.home()              # startet bei (0,0)
    Kroetchen.onclick(reagiereAufKlick)  # Bei Klick auf Kroetchen: Punkt
 
def initAnzeige():
    Anzeige.color("black")  # Schriftfarbe
    Anzeige.hideturtle()    # unsichtbare Turtle
    Anzeige.penup()         # ohne Spur
    zeigePunkteAn()

def legeFliese(x, y):
    showturtle()            # Zeige Spielfeld-Turtle (Kreis)
  # gehe in eine Fliesenecke: 
    penup()
    goto(x-Fliesenseite/2, y-Fliesenseite/2)
  # male das gefüllte Fliesenquadrat:
    pendown()            
    begin_fill()
    Quadrat(Fliesenseite)
    end_fill()
  # gehe wieder zur Mitte:
    penup()
    goto(x, y)

def Quadrat(Seite):
    for i in range(4):
        forward(Seite)
        left(90)

def aktiviereTasten():
    Spielfeld.listen()   # das Spielfeld lauscht auf die Pfeiltasten
    Spielfeld.onkey(gehe_hoch,   "Up")
    Spielfeld.onkey(gehe_runter, "Down")
    Spielfeld.onkey(gehe_rechts, "Right")
    Spielfeld.onkey(gehe_links,  "Left")
    Spielfeld.onkey(laufeParkour,"space")
    Spielfeld.onkey(speichereParkour, "s")
    Spielfeld.onkey(ladeParkour, "l")
    Spielfeld.onkey(zeigeSpielhilfe, "h")
    
def gehe_hoch():
    if ycor() < Spielfeld.window_height()/2 - Fliesenseite:
        legeFliese(xcor(), ycor() + Fliesenseite)
        Wegstrecke.append([xcor(), ycor(), 90])
        #print("Wegstrecke", Wegstrecke)
     
def gehe_runter():
    if ycor() > -Spielfeld.window_height()/2 + Fliesenseite:
        legeFliese(xcor(),ycor() - Fliesenseite)
        Wegstrecke.append([xcor(), ycor(), 270])
        #print("Wegstrecke", Wegstrecke)
     
def gehe_rechts():
    if xcor() < Spielfeld.window_width()/2 - Fliesenseite:
        legeFliese(xcor() + Fliesenseite, ycor())
        Wegstrecke.append([xcor(), ycor(), 0])
        #print("Wegstrecke", Wegstrecke)
     
def gehe_links():
    if xcor() > -Spielfeld.window_width()/2 + Fliesenseite:
        legeFliese(xcor() - Fliesenseite, ycor())
        Wegstrecke.append([xcor(), ycor(), 180])
        #print("Wegstrecke", Wegstrecke)


def deaktiviereTasten():
    Spielfeld.onkey(None, "Up")
    Spielfeld.onkey(None, "Down")
    Spielfeld.onkey(None, "Right")
    Spielfeld.onkey(None, "Left")
    Spielfeld.onkey(None, "space")
    Spielfeld.onkey(None, "s")
    Spielfeld.onkey(None, "l")

    
def laufeParkour():
    global Punkte
    deaktiviereTasten()
    hideturtle()   # verstecke Spielfeld-Turtle
    initKroete()   # Zeige Kroetchen, aktiviere Klicken
    tracer(1)      # zeige ab jetzt jeden Kroetchen-Schritt
    Punkte = 0     # Punkte zurücksetzen und anzeigen
    zeigePunkteAn()
    for i in range(len(Wegstrecke)):
        Fliese = Wegstrecke[i]
        x_Fliese = Fliese[0]
        y_Fliese = Fliese[1]
        Kroetchen.speed(5)    # beim Drehen etwas schneller sein
        Kroetchen.setheading(Fliese[2])
        Kroetchen.speed(1)    # beim Laufen langsamer sein
        Kroetchen.setpos(x_Fliese, y_Fliese)
    Kroetchen.onclick(None)   # letzte Fliese erreicht: Klick-Stopp
    tracer(0)                 # ab jetzt wieder Turbo-Modus
    aktiviereTasten()         # ab jetzt wieder alles möglich



def reagiereAufKlick (x, y):
    global Punkte
    if Kroetchen.fillcolor() == ("brown"):  # wechsele die Farbe
        Kroetchen.fillcolor("red")    
    else:
        Kroetchen.fillcolor("brown")
    Punkte = Punkte + 1       # erhöhe Punkte
    zeigePunkteAn()           # und zeige sie an


def zeigePunkteAn():
    Anzeige.clear()
    Anzeige.goto(-Spielfeld.window_width()/2+30, Spielfeld.window_height()/2-30)     # Position für Anzeige
    Anzeige.write("Punkte: "+ str(Punkte), font=("Courier", 14, ""))


##def speichereParkour():   # Basiscode für Speichern
##    fname = textinput("Wegstrecke speichern", "Dateiname: ")
##    file = open(fname, 'w')
##    for i in range(len(Wegstrecke)):
##        file.write(str(Wegstrecke[i])+'\n')
##    file.close()
##    Spielfeld.listen()

def speichereParkour():     # Code mit Fehlermeldungen und Ergänzung von .txt
    fname = textinput("Wegstrecke speichern", "Dateiname: ")
    if fname != None:
        if not fname.endswith(".txt"):   # ergänze Endung .txt
            fname = fname + ".txt"            
        try:
            file = open(fname, 'w')
            for i in range(len(Wegstrecke)):
                file.write(str(Wegstrecke[i])+'\n')
            file.close()
            print("Wegstrecke wurde gespeichert in Datei", fname)
        except: 
            print("Wegstrecke konnte nicht gespeichert werden!")
    Spielfeld.listen()      # file.close() hatte listen() deaktiviert.


##def ladeParkour():     # Basiscode für Laden
##    global Wegstrecke
##    Wegstrecke = []
##    fname = textinput("Wegstrecke laden", "Dateiname: ")
##    file = open(fname, 'r')
##    # den Text aus der Datei in ganze Zahlen umwandeln:
##    for zeile in file:
##    # alle Sonderzeichen löschen (\n, [, ]) und bei "," trennen:
##        Fliesentextliste = zeile.strip('\n').strip('[').strip(']').split(',')
##        Fliese = []
##        # alle drei Texteinträge in ganze Zahlen umwandeln:
##        for i in range(3):                 
##            Fliese.append(int(Fliesentextliste[i]))
##            Wegstrecke.append(Fliese) # Fliese an Wegstrecke hängen
##            
##    maleGeladenenParkour(Wegstrecke)
##    Spielfeld.listen() # file.close() hatte listen() deaktiviert.
 

def ladeParkour():       # Code mit Fehlermeldungen und Ergänzung von .txt
    global Wegstrecke
    Wegstrecke[:] = []
    fname = textinput("Wegstrecke laden", "Dateiname: ")
    if fname != None:
        if not fname.endswith(".txt"):
            fname = fname + ".txt"
        try:
            file = open(fname, 'r')
            # den Text aus der Datei in ganze Zahlen umwandeln:
            for zeile in file:
                # alle Sonderzeichen löschen (\n, [, ]) und bei "," trennen:
                Fliesentextliste = zeile.strip('\n').strip('[').strip(']').split(',')
                Fliese = []
                # alle drei Texteinträge in ganze Zahlen umwandeln:
                for i in range(3):                 
                    Fliese.append(int(Fliesentextliste[i]))
                # Fliese an Wegstrecke anhängen
                Wegstrecke.append(Fliese)
            file.close()
            print("Wegstrecke wurde geladen aus Datei", fname)
            maleGeladenenParkour(Wegstrecke)
        except:
            print("Daten konnten nicht geladen werden!")
    Spielfeld.listen()    # file.close() hatte listen() deaktiviert.

    
def maleGeladenenParkour(Wegstrecke):
    clear()               # alte Wegstrecken vom Spielfeld löschen
    legeFliese(0,0)       # 1. Fliese in der Mitte malen
    for i in range(len(Wegstrecke)):
        Fliese = Wegstrecke[i]
        Fl_x = Fliese[0]
        Fl_y = Fliese[1]
        legeFliese(Fl_x, Fl_y)   
    
def initSpielhilfe():
    Spielhilfe.color("darkblue")
    Spielhilfe.hideturtle()
    Spielhilfe.penup()
    zeigeSpielhilfe()

def zeigeSpielhilfe():
    Spielhilfe.clear()
    Spielhilfe.goto(-Spielfeld.window_width()/2+30, -Spielfeld.window_height()/2+90)
    Spielhilfe.write("Parkour bauen: Pfeiltasten", font=("Courier", 10, ""))
    Spielhilfe.goto(-Spielfeld.window_width()/2+30, -Spielfeld.window_height()/2+70)
    Spielhilfe.write("Parkour ablaufen: Leertaste", font=("Courier", 10, ""))
    Spielhilfe.goto(-Spielfeld.window_width()/2+30, -Spielfeld.window_height()/2+50)
    Spielhilfe.write("Punkte sammeln: Mausklick auf Schildkröte", font=("Courier", 10, ""))
    Spielhilfe.goto(-Spielfeld.window_width()/2+30, -Spielfeld.window_height()/2+30)
    Spielhilfe.write("Parkour speichern/laden: Taste S / Taste L", font=("Courier", 10, ""))
    Spielhilfe.goto(-Spielfeld.window_width()/2+30, -Spielfeld.window_height()/2+10)
    Spielhilfe.write("Spielhilfe: Taste H", font=("Courier", 10, ""))
    zeigePunkteAn()
   
     

###########################
        
## OBJEKTE UND SPIELEINSTELLUNGEN
Spielfeld = Screen()
Kroetchen = Turtle()
Kroetchen.hideturtle()  # Parkour-Turtle zunächst unsichtbar
Anzeige = Turtle()
Spielhilfe = Turtle()
tracer(0)               # Turbo-Modus: Bild neu erst bei update()

## VARIABLEN
Breite = 600            # Breite des Spielfeldes
Hoehe  = 600            # Höhe des Spielfeldes   
Fliesenseite = 40       # Größe eines Fliesenquadrats
Wegstrecke = []         # Liste der Fliesen auf dem Weg
Punkte = 0              # Wie oft wurde Kroetchen angestupst?

## INITIALISIERUNGEN
initSpielfeld(Breite, Hoehe)  # Start-Spielfeld
initAnzeige()                 # Start-Punkteanzeige
initSpielhilfe()

## PROGRAMM

aktiviereTasten()       # Bei Pfeiltasten: Fliesenlegen,
                        #   bei Leertaste: Parkourlauf
                        #   bei "s": Wegstrecke speichern
                        #   bei "l": Wegstrecke laden
while True:
    Spielfeld.update()  # Zeige Spielfeld und lausche auf Tasten






