# GedeckterTisch
# malt Ellipsen-basierte Trichter
# - Schritte: Größe der Querschnittsfigur
# - Anzahl: Anzahl der aufeinanderliegende Figuren
# - Zuwachs: Wie weit öffnet er sich?

from turtle import *


shape("turtle")
#speed(0)
tracer(0)

## QUERSCHNITTS-FIGUREN ##

def Vieleck(Schritte,Ecken):
    for i in range(Ecken):
        forward(Schritte)
        left(360/Ecken)

def Kreis(Schritte):
    Vieleck(Schritte,36)

def Halbkreis(Schritte):
    for i in range(18):
        forward(Schritte)
        left(10)
     
def Kreis_gefuellt(Schritte):
    color("orange")
    begin_fill()
    Vieleck(Schritte,36)
    end_fill()

def Rechteck(Breite,Höhe):
    for i in range(2):
        forward(Breite)
        left(90)
        forward(Höhe)
        left(90)

def Ellipse(Schritte):
     for i in range(9):       # 1. Achtelkreis (groß) 
            forward(Schritte)
            left(5) 
     for i in range(3):       # 2. Viertelkreis (klein)
            forward(Schritte)
            left(30)
     for i in range(18):      # 3. Viertelkreis (groß)
            forward(Schritte)
            left(5)
     for i in range(3):       # 4. Viertelkreis (klein)
            forward(Schritte)
            left(30)
     for i in range(9):       # 5. Achtelkreis (groß) 
            forward(Schritte)
            left(5)

def Halbellipse(Schritte):
     for i in range(9):       # 1. Achtelkreis (groß) 
            forward(Schritte)
            left(5) 
     for i in range(3):       # 2. Viertelkreis (klein)
            forward(Schritte)
            left(30)
     for i in range(9):       # 3. Achtelkreis (groß)
            forward(Schritte)
            left(5)

        
## 3D-KÖRPER ##
        
def Zylinder(Schritte,Anzahl):
    for i in range(Anzahl):
        Kreis(Schritte)
        left(90)
        forward(5)
        right(90)
        
def Quader_perspektivisch(Breite, Höhe, Anzahl):
    for i in range(Anzahl):
        Rechteck(Breite,Höhe)
        left(90)
        forward(5)
        right(90)
        forward(5)
        Breite = Breite-1   

def Trichter(Schritte,Anzahl,Zuwachs):
  for i in range(Anzahl):
    pendown()
    Ellipse(Schritte)
    penup()
    Schritte = Schritte + Zuwachs
    left(90)
    forward(4)
    right(90)
    
def Trichter_gefuellt(Schritte,Anzahl,Zuwachs,Farbe):
  fillcolor(Farbe)
  for i in range(Anzahl):
    pendown()
    begin_fill()
    Ellipse(Schritte)
    end_fill()
    penup()
    Schritte = Schritte + Zuwachs
    left(90)
    forward(4)
    right(90)


def Trompetentrichter(Schritte,Anzahl,Zuwachs):
  for i in range(Anzahl):
    pendown()
    Ellipse(Schritte)
    penup()
    Schritte = Schritte + Zuwachs
    Zuwachs = 1.1 * Zuwachs
    left(90)
    forward(3)
    right(90)
       
def Trompetentrichter_gefuellt(Schritte,Anzahl,Zuwachs,Farbe):
   fillcolor(Farbe)
   for i in range(Anzahl):
    pendown()
    begin_fill()
    Ellipse(Schritte)
    end_fill()
    penup()
    Schritte = Schritte + Zuwachs
    Zuwachs = 1.1 * Zuwachs
    left(90)
    forward(3)
    right(90)

    
##### PROGRAMM BEGINNT


## rechteckiger Tisch mit vier runden Beinen
Tischbreite = 200
Tischhöhe =20

color("brown")
penup()
home()           # 1.  Tischbein links vorne
sety(ycor()-150)
pendown()
Zylinder(2,30) 
penup()

home()           # 2.  Tischbein links hinten
sety(ycor()-100)
setx(xcor()+80)
sety(ycor()+80)
pendown()
Zylinder(2,20)

penup()
sety(ycor()-100) # 3.  Tischbein rechts hinten
setx(xcor()+ Tischbreite - 22)
pendown()
Zylinder(2,20)

penup()
home()           # 4.  Tischbein rechts vorne
sety(ycor()-150) 
setx(xcor()+ Tischbreite)
pendown()
Zylinder(2,30)

penup()          # Tischplatte
home()
pendown()
color("blue")
width(2)
Quader_perspektivisch(Tischbreite,Tischhöhe,16)

width(1)
penup()
home()          # Wasserglas, gefüllter Teil
setx(xcor()+ Tischbreite/2)
sety(ycor()+40)
pendown()
Trompetentrichter_gefuellt(2,10,0.2,"lightblue") 
penup()
home()          # Wasserglas, alles
setx(xcor()+ Tischbreite/2)
sety(ycor()+40)
pendown()
color("black")
Trompetentrichter(2,15,0.2)

hideturtle()
update()




    

