# LinienmitteFinden.py
# Du denkst, du kannst die Linienlängen erkennen. Kannst du aber nicht.

from turtle import *

speed(0)
pensize(8)

def erzeugeBalkenpfeil(): # Neue Form der Schildkröte: Balkenpfeil
    penup()
    hideturtle()
                      
    begin_poly()  # Ecke oben mittig wird die Pinselspitze sein
    left(225)     # Form ist eine Quadratecke (daher left(180 + 180/4))
    forward(60)   # erster Balken: Beginne in Ecke und male nach links unten
    left(90)
    forward(7)
    left(90)
    forward(53)

    right(90)     # zweiter Balken: Beginne in Ecke und male nach rechts unten
    forward(53)
    left(90)
    forward(7)
    left(90)
    forward(60)
    home()        # Ausrichtung des Shapes nach rechts
    end_poly()
   
    register_shape("Balkenpfeil", get_poly()) # Shape wurde erstellt
     
def maleLinie():
    home()
    penup()
    goto(-250, 0)	# Position des linken Endes der Linie
    left(45)            # linke Pfeilspitze
    pendown()
    color("darkred")
    forward(60)
    backward(60)
    right(90)
    forward(60)
    backward(60)
    left(45)
    forward(8)

    color("darkblue")
    forward(492)	# die Linie wird gemalt: 500 Schritte lang
 
    left(45)            # rechte Pfeilspitze
    color("darkred")
    forward(60)
    backward(60)
    right(90)
    forward(60)
    backward(60)
    left(45)
        
def lauscheTasten():     # lausche fortwährend auf Tastendrücke
    listen() 
    onkey(gehe_rechts, "Right")
    onkey(gehe_links,  "Left")
    onkey(stoppe,      "space")

def gehe_rechts():
     setx(xcor()+10)
     
def gehe_links():
     setx(xcor()-10)
     
def stoppe():
    if xcor()> 10 :
        print("Du bist um", xcor()-10, " Schritte zu weit rechts.")
    else:
        if xcor()<10:
            print("Du bist um", abs(xcor()-10), " Schritte zu weit links.")
        else:
            print("Du bist genau in der Mitte! Glückwunsch!")

    
##### PROGRAMM 

erzeugeBalkenpfeil() # definiert neues Shape für die Schildkröte
maleLinie()          # malt die blaue Linie und die Begrenzungen
lauscheTasten()      # verwendet listen() und onkey(..)

penup()
goto(-230, 0)	     # Position der Balkenpfeil-Spitze ganz links
shape("Balkenpfeil")
color("darkred")
showturtle()

while True:
    update()
    
