# Muscheln_und_Meer.py
# malt Muscheln, Schwimmringe und mehr

from turtle import *
from random import *


shape("turtle")
#speed(0)
tracer(0)

## QUERSCHNITTS-FIGUREN (zweidimensional) ##

def Vieleck(Schritte,Ecken):
    for i in range(Ecken):
        forward(Schritte)
        left(360/Ecken)

def Vieleck_gefüllt(Schritte,Ecken,Farbe):
    fillcolor(Farbe)
    begin_fill()
    Vieleck(Schritte,Ecken)
    end_fill()
    
def Kreis(Schritte):
    Vieleck(Schritte,36)

def Halbkreis(Schritte):
    for i in range(18):
        forward(Schritte)
        left(10)
     
def Kreis_gefüllt(Schritte):
    color("orange")
    begin_fill()
    Vieleck(Schritte,36)
    end_fill()

def Rechteck(Breite,Hoehe):
    for i in range(2):
        forward(Breite)
        left(90)
        forward(Hoehe)
        left(90)

def Ellipse(Schritte):
     for i in range(9):       # 1. Achtelkreis (groß) 
            forward(Schritte)
            left(5) 
     for i in range(3):       # 2. Viertelkreis (klein)
            forward(Schritte)
            left(30)
     for i in range(18):      # 3. Viertelkreis (groß)
            forward(Schritte)
            left(5)
     for i in range(3):       # 4. Viertelkreis (klein)
            forward(Schritte)
            left(30)
     for i in range(9):       # 5. Achtelkreis (groß) 
            forward(Schritte)
            left(5)

def Halbellipse(Schritte):
     for i in range(9):       # 1. Achtelkreis (groß) 
            forward(Schritte)
            left(5) 
     for i in range(3):       # 2. Viertelkreis (klein)
            forward(Schritte)
            left(30)
     for i in range(9):       # 3. Achtelkreis (groß)
            forward(Schritte)
            left(5)

        
######### 3D-KÖRPER ##
        
def Zylinder(Schritte,Anzahl):
    for i in range(Anzahl):
        Kreis(Schritte)
        left(90)
        forward(5)
        right(90)

def Buddelförmchen(Schritte,Ecken,Anzahl,Farbe):
    Vieleck_gefüllt(Schritte,Ecken,Farbe)
    for i in range(Anzahl):
        Vieleck(Schritte,Ecken)
        Schritte = Schritte + 2
        
def Quader_perspektivisch(Breite, Hoehe, Anzahl,Farbe):
    for i in range(Anzahl):
        Rechteck(Breite,Hoehe)
        left(90)
        forward(5)
        right(90)
        forward(5)
        Breite = Breite-1   

def Trichter(Schritte,Anzahl,Zuwachs):
  for i in range(Anzahl):
    Ellipse(Schritte)
    Schritte = Schritte + Zuwachs
    left(90)
    forward(4)
    right(90)

    
def Trichter_gefüllt(Schritte,Anzahl,Zuwachs,Farbe):
  fillcolor(Farbe)
  for i in range(Anzahl):
    begin_fill()
    Ellipse(Schritte)
    end_fill()
    Schritte = Schritte + Zuwachs
    left(90)
    forward(4)
    right(90)


def Trompetentrichter(Schritte,Anzahl,Zuwachs):
  for i in range(Anzahl):
    pendown()
    Kreis(Schritte)
    penup()
    Schritte = Schritte + Zuwachs
    Zuwachs = 1.1 * Zuwachs
    left(90)
    forward(3)
    right(90)
       

def Muschel_rechts(Schritte,Anzahl,Zuwachs):
  for i in range(Anzahl):
    pendown()
    Kreis(Schritte)
    penup()
    Schritte = Schritte + Zuwachs
    Zuwachs = 1.01 * Zuwachs
    left(90)
    forward(3)
    right(90)
    right(7)

def Muschel_links(Schritte,Anzahl,Zuwachs):
    green=0
    for i in range(Anzahl):
        green = green + 1/Anzahl
        color(0,green,0)
        pendown()
        Kreis(Schritte)
        penup()
        Schritte = Schritte + Zuwachs
        Zuwachs = 1.01 * Zuwachs
        left(90)
        forward(3)
        right(90)
        left(7)

def Schwimmring(Schritte,Anzahl):
    for i in range(Anzahl):
        Kreis(Schritte)
        left(90)
        forward(5)
        right(90)
        left(360/Anzahl)

def Rettungsring(Schritte,Anzahl):
    for i in range(4):
        for i in range(int(Anzahl/4)):
            color("red")       # 1. u. 3. Viertelkreis rot
            Kreis(Schritte)
            left(90)
            forward(5)
            right(90)
            left(360/Anzahl)
        for i in range(int(Anzahl/4)):
            color("lightgrey") # 2. u. 4. Viertelkreis weiß
            Kreis(Schritte)
            left(90)
            forward(5)
            right(90)
            left(360/Anzahl)


def Kugel(Schritte, Anzahl):
    Anfangsschritte = Schritte
    green = 0
    for i in range(Anzahl):
        green = green + 1/Anzahl
        color(0,green,0)
        Kreis(Schritte)
        Schritte = Schritte + 1
    Halbkreis(Schritte)
    Schritte = Anfangsschritte
    green = 0
    for i in range(Anzahl):
        green = green + 1/Anzahl
        color(0,green,0)
        Kreis(Schritte)
        Schritte = Schritte + 1


def Ellipsoid(Schritte, Anzahl):
    Anfangsschritte = Schritte
    purple = 0
    for i in range(Anzahl):
        purple = purple + 1/Anzahl
        color(purple,0,purple)
        Ellipse(Schritte)
        Schritte = Schritte + 1
    Halbellipse(Schritte)
    Schritte = Anfangsschritte
    purple = 0
    for i in range(Anzahl):
        purple = purple + 1/Anzahl
        color(purple,0,purple)
        Ellipse(Schritte)
        Schritte = Schritte + 1        

        
##### PROGRAMM BEGINNT
#penup()
#goto(-200,-200)
#pendown()


#Muschel_links(4,120,0.1)
#Muschel_rechts(4,90,0.1)

#Schwimmring(10,200)
#Rettungsring(10,200)

#Kugel(1,20)
#left(180)
#Ellipsoid(1,20)

#Buddelförmchen(30,5,20,"red") #(Schritte,Ecken,Anzahl,Farbe)
Buddelförmchen(10,20,10,"orange")

hideturtle()
update()




    

